
;+ ***********************************************************************
; NAME:
;	NRH_VERIF
;
; PURPOSE:
;	Cette procedure visualise le contenu de l'entete d'un fichier NRH1
;	au format HELIO
;
; CATEGORY:
;	NRH1 fichier
;
; CALLING SEQUENCE:
;	NRH_VERIF, Fich
;
; INPUTS:
;	FICH	nom du fichier
;	
; KEYWORD PARAMETERS:
;	LUN	Unite logique de lecture
;
; OUTPUTS:
;	Listing de l'entete du fichier sous forme resumee
;
; COMMON BLOCKS:
;	NRH1_GLOBAL
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	13/11/98 Adapte du logiciel XHELIO
;-*******************************************************************


PRO NRH_Verif, fich, lun=lun

COMMON NRH1_GLOBAL , nomfich,fichinfo
                                         ; teste la presence de parametres
IF N_ELEMENTS(lun) EQ 0 THEN BEGIN       ; aucune unite logique de specifie
   n=8                                   ; recherche d'une unite logique libre
   nb=0
   REPEAT BEGIN
   n=n+1
   nb=nb+1
   IF n EQ 10 THEN n=1
   ENDREP UNTIL (NomFich(n) EQ '') OR (Nb GE 10)
   IF Nb GE 10 THEN n=9 
ENDIF ELSE n=lun
IF N_ELEMENTS(Fich) EQ '' THEN $
BEGIN           
     Fich=''    
     READ, 'Nom du fichier :',Fich
ENDIF

err=NewLitEntete(n,Fich,FileInfo)             ; lecture de l'entete
IF err EQ 1 THEN RETURN
  

;
Num=0                                   ; initialisation des variables
Tempo =''
Tempo1=''
Tempo2=''
Tempo3=''
Tempo4=''
Tempo5=''
Spc   ='    '
Spc2=spc+spc+spc                 
NbInc=0
Inc= StrArr(50)
Tx = StrArr(60)             ; Le tableau TX contient le texte a afficher 

for i=0,59 do Tx(i)='                          '
for i=0,49 do Inc(i)='                          '


TX(1)='-------------------------------------------------------------------'
Tx(2)='	  FICHIER :'+FILEINFO.NOMFICH+'   '+FILEINFO.DATE
TX(3)='-------------------------------------------------------------------'
Inc(1)=Tx(1)
Inc(2)=Tx(2)
Inc(3)=Tx(3)
NbInc=4

TX(4)=''
Tx(5)= ' Valeur Minimum :'+ STRCOMPRESS(STRING(fileinfo.Valmin)) 
Tx(6)= ' Valeur Maximum :'+ STRCOMPRESS(STRING(fileinfo.Valmax)) 
WHILE FileInfo.Texte.Mot(num) NE 'END' DO BEGIN 
 Mot=FileInfo.Texte.Mot(Num)
 Val=FileInfo.Texte.Val(Num)
 CASE Mot OF                                  ; recherche des differents mots
   'FREQ' : Tx(7)= ' Frequence      : '+ val
   'UNIT' : Tx(4)= ' Unite          : '+ val
   'UNIT1': BEGIN
               Tx(8)= ' AXE 1...Unite           : '+ val
               IF Tempo1 NE '' THEN Tx(8)=Tx(8)+Spc+Tempo1
            END
   'UNIT2': BEGIN
               Tx(12)= ' AXE 2...Unite           : '+ val
               IF Tempo2 NE '' THEN Tx(12)=Tx(12)+Spc+Tempo2
            END
   'UNIT3': BEGIN
               Tx(16)= ' AXE 3...Unite          : '+ val
               IF Tempo3 NE '' THEN Tx(16)=Tx(16)+Spc+Tempo3
            END
   'UNIT4': BEGIN
               Tx(20)= ' AXE 4...Unite          : '+ val
               IF Tempo4 NE '' THEN Tx(20)=Tx(20)+Spc+Tempo4
            END
   'UNIT5': BEGIN
               Tx(24)= ' AXE 5...Unite          : '+ val
               IF Tempo5 NE '' THEN Tx(24)=Tx(24)+Spc+Tempo5
            END
   'AXE1' : IF Tx(8) NE '' THEN Tx(8)=Tx(8)+spc+val ELSE Tempo1=val
   'AXE2' : IF Tx(12) NE '' THEN Tx(12)=Tx(12)+Spc+val ELSE Tempo2=val
   'AXE3' : IF Tx(16) NE '' THEN Tx(16)=Tx(16)+spc+val ELSE Tempo3=val
   'AXE4' : IF Tx(20) NE '' THEN Tx(20)=Tx(20)+spc+val ELSE Tempo4=val
   'AXE5' : IF Tx(24) NE '' THEN Tx(24)=Tx(24)+spc+val ELSE Tempo5=val
   'ORGANISATION': BEGIN
                     Tx(28)= ' '+val
                     IF Tempo NE '' THEN Tx(28)=Tx(28)+Spc+Tempo
                   END
   'LABEL': IF Tx(28) NE '' THEN Tx(28)=Tx(28)+spc+val ELSE Tempo=val
   'TYPE' : Tx(29)=' '+STRLOWCASE(Mot)+': '+Val
   'INSTRUMENT': Tx(30)= ' '+STRLOWCASE(mot)+': '+Val
   'ENTETDESC1': Tx(34)= 'Entete 1....Desc    : '+Val
   'ENTETLONG1': Tx(35)= spc2+'Longueur: '+val 
   'ENTETUNIT1': Tx(36)= spc2+'Unite   : '+val 
   'ENTETTYP1' : Tx(37)= spc2+'Type    : '+val 
   'ENTETDESC2': Tx(38)= 'Entete 2....Desc    : '+Val
   'ENTETLONG2': Tx(39)= spc2+'Longueur: '+val 
   'ENTETUNIT2': Tx(40)= spc2+'Unite   : '+val 
   'ENTETTYP2' : Tx(41)= spc2+'Type    : '+val 
   'ENTETDESC3': Tx(42)= 'Entete 3....Desc    : '+Val
   'ENTETLONG3': Tx(43)= spc2+'Longueur: '+val 
   'ENTETUNIT3': Tx(44)= spc2+'Unite   : '+val 
   'ENTETTYP3' : Tx(45)= spc2+'Type    : '+val 
   'FICHIER': 
   Else: BEGIN
           IF Mot NE '' THEN Inc(nbInc)=mot+ ' = '+ val     
           NbInc=NbInc+1
         END
 ENDCASE 
 Num=Num+1
ENDWHILE
Spc='         '                     ; traitement de TX pour les differents axes
FOR i=0,FileInfo.NbAxes-1 DO BEGIN
    IF FileInfo.OrgInt(i) NE 0 THEN BEGIN 
       val=STRCOMPRESS(STRING(LONG(fileinfo.Valorg(i))))   
       pas=STRCOMPRESS(STRING(LONG(fileinfo.PasPix(i))))
    ENDIF ELSE BEGIN  
       val=STRCOMPRESS(STRING(fileinfo.Valorg(i)))   
       pas=STRCOMPRESS(STRING(fileinfo.PasPix(i)))  
    ENDELSE
    IF Tx(8+i*4) EQ '' THEN Tx(4+i*4)=' AXE '+STRCOMPRESS(STRING(i+1))+'  .......' 
    Tx(9+i*4)=spc+'Nombre de points:'+STRCOMPRESS(STRING(fileinfo.Nbpix(i))) 
    Tx(10+i*4)=spc+'Origine         :'+val 
    Tx(11+i*4)=spc+'Increment       :'+pas
ENDFOR

;
;                  Traitement de Tx pour les facteurs de blocage 
;

FOR i=0,4 DO Tx(46+i)='Axe '+STRCOMPRESS(STRING(i+1))+ $
                      ' contient '+STRCOMPRESS(STRING(fileinfo.facbloc(i)))+ $
                      ' information(s)' 

Tx(51)= ' Date de l''enregistrement: '+fileinfo.date+ $
        ',    Taille d''un enregistrement:'+          $
        STRCOMPRESS(STRING(fileinfo.tenre))
Tx(52)= ' heure de debut d''enregistrement : '+MSH(fileinfo.heurdeb)
Tx(53)= ' heure de fin   d''enregistrement : '+MSH(fileinfo.heurfin)
 
IF fileinfo.imint EQ 1 THEN Tx(54)= ' Entete d''image entiere' $
                       ELSE Tx(55)= ' Entete d''Image reelle '


NRH1_xtext,Tx

CLOSE,n
END

