
;+ ***********************************************************************
; NAME:
;	MOTCLE
;
; PURPOSE:
;	Cette fonction lit la valeur associee a un motcle
;
; CATEGORY:
;	NRH1 general
;
; CALLING SEQUENCE:
;	Result = MOTCLE( Unit, 'Cle')
;
; INPUTS:
;	UNIT	Unite de lecture associee au fichier
;
;	CLE	Nom du mot cle
;
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	RESULT  contenu d'un motcle dans le descripteur de donnees de 
;		type HELIO
;		-1 en cas d'erreur
;
; COMMON BLOCKS:
;	NRH1_GLOBAL
;
; RESTRICTIONS:
;	FICHINFO(Unit).nomfich doit contenir le nom du fichier
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	13/11/98 Adapte du logiciel XHELIO
;-*******************************************************************


FUNCTION MOTCLE, N,CLE

	COMMON NRH1_GLOBAL, NOMFICH,FICHINFO
	   
        IF (FICHINFO(N).NOMFICH EQ '') THEN BEGIN
           	R=WIDGET_MESSAGE('This file not exists')
           RETURN,-1
        ENDIF
        I=0
	WHILE (FICHINFO(N).TEXTE.MOT(I) NE 'END') AND $
		(FICHINFO(N).TEXTE.MOT(I) NE CLE) DO I=I+1
	IF (FICHINFO(N).TEXTE.MOT(I) EQ 'END') THEN BEGIN
		R=WIDGET_MESSAGE(' Mot cle '+ CLE+' not exists')
               RETURN,-1
        ENDIF
;
	RETURN, Fichinfo(n).texte.Val(i)
End
