pro verif_canaux, file, CANAUX=canaux, icandeb, icanfin

;-----------------------------------------------------
; VERIFICATION DES PARAMETRES canaux: 
;
; Parametres: 	file	structure 
;		canaux	canaux debut, fin (modifies a la sortie)
;		icandeb	Numero du point correspondant au canal de debut
;		icanfin	idem pour le canal fin
;
; Modification: Calcul des numeros des canaux correspondant a cdeb, cfin
;               par la fonction NUMCANAL  11 nov 1997, KLK

canaldeb=fix(file.valorg(0))
canalfin=fix(file.valorg(0)+file.paspix(0)*file.nbpix(0)-1)
IF NOT KEYWORD_SET(canaux) THEN BEGIN
   cdeb=canaldeb
   cfin=canalfin
ENDIF ELSE BEGIN
   cdeb=canaux(0)
   cfin=canaux(1)
ENDELSE

IF (cdeb LT canaldeb) THEN cdeb = canaldeb
IF (cfin GT canalfin) THEN cfin = canalfin

IF (cfin-cdeb LT 0) THEN BEGIN
	aux = cfin
	cfin = cdeb
	cdeb = aux
ENDIF

icandeb= NUMCANAL(canaldeb, file.paspix(0), CHANNEL=cdeb)
icanfin= NUMCANAL(canaldeb, file.paspix(0), CHANNEL=cfin)
cdeb = icandeb*file.paspix(0) + canaldeb	; canal debut
cfin = icanfin*file.paspix(0) + canaldeb	; canal fin
canaux = [cdeb, cfin]

RETURN
END