
;+ ***********************************************************************
; NAME:
;		CTRL_NRHFILE
;
; PURPOSE:
;	Cette fonction identifie le contenu d'un fichier: type de donnees,
;	reseau etc....
;
; CATEGORY:
;	Fichiers NRH
;
; CALLING SEQUENCE:
;	I = CTRL_NRHFILE ( FILE)
;
; INPUTS:
;	FILE	nom du fichier
;	
; KEYWORD PARAMETERS:
; 	CONTENT		verification du type de donnees (Images, Harmoniques, 
;			Flux, Centres Actifs, etc...). Voir CW_NRHFILE pour
;			la liste des codes

;	ARRAY		Reseau (non traite pour l'instant)
;
; OUTPUTS:
;	Retour: 1 si le fichier correspond au code, sinon 0
;
; PROCEDURE:
;	You can describe the foobar superfloatation method being used here.
;	You might not need this section for your routine.
;
; EXAMPLE:
;	IF CTRL_NRHFILE( File, CONTENT = 'f') THEN $
;		Print,'c'est un fichier de FLUX'
;
; MODIFICATION HISTORY:
;	Ecrit par: J BONMARTIN le 13/02/98 (bonmartin@obspm.fr)
;		Le 18/01/01 ne pas tester CONTENT si nom non standard NRH (JB)
;-*******************************************************************

FUNCTION CTRL_NRHFILE, FILE, CONTENT = Content, ARRAY = array

; Extraction du nom de fichier
;print,'file>',file,'<'
	SEP ='/'
	IF !VERSION.OS_FAMILY EQ 'Windows' THEN Sep ='\'
if file eq '' then return, 0
	DECOMP = STR_SEP( File, Sep)
	FNAME = Decomp[ ((size( Decomp)) (1)) -1]

; Seperation des champs de fichier
	DCF = STR_SEP( Fname, '_')

; Traitement du parametre considere
	IF KEYWORD_SET (CONTENT) AND N_ELEMENTS(Dcf) GT 2 THEN $
		IF strmid(Dcf(2),0,1) EQ CONTENT THEN RETURN, 1 $
			ELSE RETURN, 0
; Rajouter les autres cas

RETURN, 1

END

