
;+ ***********************************************************************
; NAME:
;	FOPEN_GIF
;
; PURPOSE:
;	Lecture des donnees sous forme d'image GIF
;
; CATEGORY:
;	Fichier
;
; CALLING SEQUENCE:
;	 FOPEN_GIF,File, Str_inf2d

;
; INPUTS:
;	File	chemin et nom du fichier a lire
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;	Str_inf2d	structure d'information de fichier (NRH_STR_INF2D)
;
; PROCEDURE:
;	Cette procedure lit l'image contenue dans un fichier FITS GIF,
;	l'affiche et demande de determiner le cercle optique, puis
;	remplit la structure STR_INF2D
;;			  Str_inf2d.Content est = 'GIF'
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (bonmartin@obspm.fr) le 09/09/98
;-*******************************************************************

PRO FOPEN_GIF, File, Str_inf2d

Str_inf2d.Instrume = 'GIF'
	READ_GIF,File, data, R, G ,B
	Optic_circ, DATA, Xcen, Ycen, Ray

	STR_Inf2d.Xcen=Xcen&Str_inf2d.Ycen=Ycen
	Str_inf2d.ray=ray
	Str_inf2d.CONTENT = 'GIF'
	str_inf2d.nim = 1
	Str_inf2d.hd = ''
	Str_inf2d.hf = Str_inf2d.hd
		SZ = SIZE( Data)
	Str_inf2d.npx = Sz(1)
	Str_inf2d.npy = Sz(2)
	  	Str_inf2d.Tscan = 0.0
		Str_inf2d.Freq = 0.0
		Str_inf2d.date = ''

END