

;+ ***********************************************************************
; NAME:
;	NRH_FILTER
;
; PURPOSE:
;	Cette procedure definit le PATH pour la lecture des fichiers images
;	et permet de selectionner un fichier 
;		     lister les HEADERS
; CATEGORY:
;	Fichiers
;
; CALLING SEQUENCE:
;	NRH_FILTER
;
; INPUTS:
;	Non.
;
; KEYWORD PARAMETERS:
;	GROUP	Identifieur du WIDGET appelant
;
; OUTPUTS:
;	non
;
; COMMON BLOCKS:
;	Non
;
; SIDE EFFECTS:
;	Fixe le PATH des fichiers images pour toute la cession
;
; PROCEDURE:
;	You can describe the foobar superfloatation method being used here.
;	You might not need this section for your routine.
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin le 10/07/98 (bonmarti@obspm.fr)
;-*******************************************************************

PRO NRH_FILTER_EVENT, event

COMMON FICRH, Str_fic
COMMON INFO2D, Str_inf2d
COMMON LIMIT, Str_lim

COMMON COM_NRH_FILTER, Binfo, Bhr, Extd, Heure

WIDGET_CONTROL, event.id, Get_Uvalue = ev

CASE EV of
	'Instrum': BEGIN
                Instrum = event.index

		IF Instrum EQ 0 Then $
			Str_fic.Filtre = '*'
		IF Instrum EQ 1 Then $
			str_fic.filtre=cw_nrh_filter(GROUP= event.top)
		IF Instrum EQ 2 Then $
			str_fic.filtre = 'seit*.fts'
		IF Instrum EQ 3 Then $
			Str_fic.filtre = '*.fits'
		IF Instrum EQ 4 Then $
			str_fic.filtre = '*.png'


                  END

        'Select': BEGIN
		NRH_PICKFILE, Str_fic, Str_inf2d, Str_lim, List_stk, Lfreq
                 Binfo = cw_infonrh(binfo,Str_inf2d, / INFO)
                 END

	'Repert': Str_fic.rep = event.value

	'Exten':  Extd = event.value
	'Header': BEGIN
                  IF Str_fic.file EQ '' THEN BEGIN
                     R= WIDGET_MESSAGE('First select a FILe')
                  RETURN & END
                  CW_header, Str_fic.file, EXTEN=Extd, GROUP = event.top
                  END

	'Help':   help_file	

	'Return': BEGIN
			WIDGET_CONTROL, event.top, /DESTROY
			NRH_FCLOSE,Str_inf2d
			END

ENDCASE

END


PRO NRH_FILTER, GROUP=Group

COMMON FICRH, Str_fic
COMMON INFO2D, Str_inf2d
COMMON LIMIT, Str_lim

COMMON COM_NRH_FILTER, Binfo,Bhr, Extd, Heure

EXTD = 0

IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

	LISTINSTR=[ $
		'All FILES', $
		'NRH', $
		'SOHO EIT', $
		'Base MEUDON', $
		'PNG' $
			]

BASE = WIDGET_BASE(GROUP_LEADER= group, TITLE= 'FILES FILTER', /COLUMN)

B1= WIDGET_BASE(base,/column,/align_center,/frame)
	B= WIDGET_LABEL(B1,Value='File FILTER:',/align_center)
        B=  CW_FIELD(B1,/return_event,TITLE='Directory:', Uvalue='Repert', $
		Value= Str_fic.rep, /string, Xsize=30,/all_events)
	B= WIDGET_DROPLIST(B1, Value=Listinstr, Uvalue='Instrum', $
		TITLE='Instrument:')

B2= WIDGET_BASE(base,/column,/align_center,/frame)
	B= WIDGET_LABEL(B2,Value='File CONTROL:',/align_center)
	B= WIDGET_BUTTON(B2, Value='Select File', Uvalue='Select')
	B= WIDGET_BUTTON(B2, Value='Print Header', Uvalue='Header')
	B= CW_FIELD(B2,/Integer,Title='HEADER Extend:',/Return_event, $
		Xsize=2, Value=Extd, Uvalue= 'Exten',/all_events)

        Binfo = cw_infonrh(B2, Str_inf2d)

B= WIDGET_BUTTON(Base, Value='Help', Uvalue='Help')

B4 = WIDGET_BUTTON(Base, Value='RETURN', Uvalue='Return')

WIDGET_CONTROL, base, /Realize
XMANAGER, 'NRH_FILTER', base,/NO_BLOCK

END

