
;+ ***********************************************************************
; NAME:
;	RD_STDFITS
;
; PURPOSE:
;	Lecture d'image au format FITS dans unfichier contenant une image
;
; CATEGORY:
;	Fichiers NRH
;
; CALLING SEQUENCE:
;	 RD_STDFITS, File, Str_fic, Image, Str_im
;
; INPUTS:
;	File	chemin et nom du fichier a lire
;	Str_fic	Structure d'information de fichiers (NRH_STR_INFIC)
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;	Image	tableau d'image
;	Str_im	Structure d'image (NRH_STR_IMAGE)
;
; PROCEDURE:
;	Cette procedure lit l'image contenue dans un fichier FITS ,
;	cree et remplit la structure STR_IM
;	La structure STR_FIC doit avoit ete correctement remplie par un appel
;	a NRH_FOPEN correspondant a l'instrument choisi
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin le 14/09/98 (bonmartin@obspm.fr)
;-*******************************************************************

PRO RD_STDFITS, File, Str_inf2d, Image, Str

STR = {nrh_str_image}

        IMAGE = mrdfits(file,0, Hd, /SILENT)
 
	Str.date = Str_inf2d.date
	Str.time = Str_inf2d.hd
	IF Str_inf2d.Freq NE 0 THEN $
		Str.Freq = STRCOMPRESS(Str_inf2d.Freq,$
				/REMOVE_ALL)+'MHz'
	Str.Instrume = Str_inf2d.instrume
	Str.Crpixx =  Str_inf2d.Xcen
	Str.Crpixy =  Str_inf2d.Ycen
	Str.Ray = Str_inf2d.Ray
end