



;+ ***********************************************************************
; NAME:
;	IND_RS
;
; PURPOSE:
;	Cette fonction donne  la coordonnee d'un pixel en RAYON SOLAIRE,
; a partir de l'indice du pixel, l'indice du centre le l'image, 
; la dimension du rayon solaire en pixels
;
; CATEGORY:
;	RADIO
;
; CALLING SEQUENCE:
;	RS=IND_RS(ind, pcentre, rayon)
;
; INPUTS:
;	IND	Indice du pixel
;	Pcentre Indice du centre de l'image
;	Rayon	Nombre de pixels representant le rayon solaire
;
; OUTPUTS:
;	RS	Coordonnee en rayon solaire
;
; EXAMPLE:
;	RS = IND_RS(15, 32, 16)
; Rs coordonne en rayon solaire du 16ieme pixel d'une image de 64 pixels
; dont le centre est sur le 32ieme point, l'image representant 4 rayons
; solaires 
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin le 21/10/97 (bonmartin@obspm.fr)
;-*******************************************************************


FUNCTION IND_RS, ind, pcentre, rayon
        centre = pcentre /rayon
        rs =  (FLOAT(ind) / rayon) -centre

return, rs

end
