
;+ *************************************************************************************
; NAME:
;	RDLINE_FPOS
;
; PURPOSE:
;	Cette procedure lit une source d'une position et la renvoie sous forme 
;	d'une structure de type GAUSS (max, xamx, ymax, gra, grb, tet)
;
; CATEGORY:
;	RH_2D, recherche de positions
;
; CALLING SEQUENCE:
;	RDLINE_FPOS, Fichpos, NumPos, NumLigne, Gauss
;
; INPUTS:
;	Fichpos:	Fichier fits contenant les positions
;	NumPos:		Numero de la position
;	NumLigne:	Numero de la ligne
;
; OUTPUTS:
;	Gauss:		structure de type gauss 
;
; MODIFICATION HISTORY:
;	Ecrit par: 	C Renie aout 1998
;- *************************************************************************************


PRO rdline_fpos, fichposi, posi, ligne, str_gauss
	
	t = rdfilepos(fichposi, 'INTENSITY', posi)
	str_gauss.max = t(ligne)
	t = rdfilepos(fichposi, 'EWPOS', posi)
	str_gauss.xmax = t(ligne)
	t = rdfilepos(fichposi, 'NSPOS', posi)
	str_gauss.ymax = t(ligne)
	t = rdfilepos(fichposi, 'MAJAXIS', posi)
	str_gauss.gra = t(ligne)
	t = rdfilepos(fichposi, 'MINAXIS', posi)
	str_gauss.grb = t(ligne)
	t = rdfilepos(fichposi, 'ANGLE', posi)
	str_gauss.tet = t(ligne)

END
