;+
; NAME:
;	SELTIME.PRO
;
; PURPOSE:
;	Affiche une widget pour selection des heures de debut et de fin
;
; CATEGORY:
;	RH_2D, recherche de positions
;
; CALLING SEQUENCE:
;
;	heures = SELTIME, Hdeb, Hfin, GROUP=group
;
; INPUTS:
;	Hdeb, Hfin: valeurs initiales des heures de debut et de fin
;
; OUTPUTS:
;	heures: tableau de 2 chaines de caracteres contenant les heures selectionnees
;
; MODIFICATION HISTORY:
; 	Written by:	Christian Renie
;	Avril, 1999
;-

PRO SELTIME_Event, Event

COMMON DAT_SELTIME, heure, FTDEB, FTFIN

  Sortie = 'No'

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 
	'BUTDONE': BEGIN
		WIDGET_CONTROL, FTDEB, GET_VALUE=temp
		heure(0)=temp(0)
		WIDGET_CONTROL, FTFIN, GET_VALUE=temp
		heure(1)=temp(0)
		Sortie='Yes'
	END
	'BUTCANC': BEGIN
		Sortie='Yes'
	END
  ENDCASE
  IF sortie EQ 'Yes' THEN WIDGET_CONTROL, Event.Top, /DESTROY
END


; DO NOT REMOVE THIS COMMENT: END MAIN13
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.



FUNCTION SELTIME, hdeb, hfin, GROUP=Group

COMMON DAT_SELTIME, heure, FTDEB, FTFIN

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }

  heure = STRARR(2)
  heure(0)=Hdeb
  heure(1)=Hfin

  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      UVALUE='MAIN13')

  FTDEB = CW_FIELD( MAIN13,VALUE=Hdeb, $
      ROW=1, $
      STRING=1, $
      FRAME=1, $
      TITLE='From:', $
      UVALUE='FTDEB', $
      XSIZE=14)

  FTFIN = CW_FIELD( MAIN13,VALUE=Hfin, $
      ROW=1, $
      STRING=1, $
      FRAME=1, $
      TITLE='To:', $
      UVALUE='FTFIN', $
      XSIZE=14)

  BUTDONE = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTDONE', $
      VALUE='Done')

  BUTCANC = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTCANC', $
      VALUE='Cancel')

  WIDGET_CONTROL, MAIN13, /REALIZE

  XMANAGER, 'SELTIME', MAIN13

  RETURN, heure
END
