pro rh_cr_header_bt,header
;+ ***********************************************************************
; NAME:
;	RH_CR_HEADER_BT
; PURPOSE:
;	Cette procedure cree un HEADER FITS PRIMAIRE MODELE pour les fichiers
;	2D FITS type BINARY TABLE
;	fichier contenant des IMAGES 2D Nancay .
;	Ce header modele est mis a jour par le programme DPATCHFITS  
; CATEGORY: 
;	Traitement de fichiers NRH
; CALLING SEQUENCE:
;	RH_CR_HEADER_BT, header
; OUTPUTS:
;	Header:	header
; MODIFICATION HISTORY:
;	Ecrit par: A. Bouteille
;-*******************************************************************
;0000000001111111111222222222233333333334444444444555555555566666666667
;1234567890123456789012345678901234567890123456789012345678901234567890
;36 lignes max
tab=[	$
"XTENSION= 'BINTABLE'           /",	$
"BITPIX  =                    8 /",	$
"NAXIS   =                    2 /",	$
"NAXIS1  =                32776 / 4 + 4 + ndim*ndim*4 + ndim*ndim*4  ",	$
"NAXIS2  =                    0 /",	$
"DATE-OBS= '27-OCT-82'          /",     $
"TIM_STR = '00:00:00:000'       /", $
"TIM_END = '00:00:00:000'       /", $
"FREQ    =                164.0 /",	$
"FREQUNIT=                    6 / in MHz",	$
"HMER    = '12:00:00.00'        /heure du meridien ",      $
"DECL    = '00D00M00.00'        /declinaison en degres ",  $
"UV_COV_A= 'NO       '          /ANTENNAS for low 50m odd multiple baseline ",$
;                                the so-called anti-aliasing antennas
"UV_COV_C= 'NO       '          /INTERPOLATION for 50m odd multiple baseline",$
; 2 mots_cle pour definir sur quels domaines s'appliquent les 2 etapes
; du clean :   
; etape 1-  CLN_SRCH    search  dirty components
;                = NONE           ( mode_clean = 0)
;                = FULL IMAGE     ( mode_clean = 1 et 2)
;                = INSIDE DOMAIN  ( mode_clean = 3 et 4)
; etape 2-  CLN_RSTR    restore clean components
;                = FULL IMAGE     ( mode_clean = 1)
;                = OUTSIDE DOMAIN ( mode_clean = 2)
;                = NONE           ( mode_clean = 0 et 3)
;                = OUTSIDE DOMAIN ( mode_clean = 4)
 
"CLN_SRCH= 'NONE     '          /clean : search dirty components",$
"CLN_RSTR= 'NONE     '          /clean : restore clean components",$
"CRPIX1  =                    0 /SUN CENTER X, in pixels", $
"CRPIX2  =                    0 /SUN CENTER Y, in pixels", $
"SOLAR_R =                    0 /SOLAR RADIUS, in pixels", $ 
"EXPTIME =                    0 /SAMPLING PERIOD, in seconds", $
"TIMESTEP=                    0 /INTEGRATION TIME, in seconds", $
"BUNIT   = '   '                / brightness in sfu/pixel or in K degrees",$
"PCOUNT  =                    0 /",     $
"GCOUNT  =                    1 /",     $
"TFIELDS =                    4 /3 or 4 COLUMNS BINARY TABLE",	$
"TFORM1  = '1J      '           /",	$
"TTYPE1  = 'TIME'               /TIME, IN MILLISECS",	$
"TRVAL1  =                    0 /",	$
"TDELT1  =                  100 /",	$
"TRPIX1  =                    1 /",	$
"TFORM2  = '1J      '           /",	$
"TTYPE2  = 'NUMIM'              /IMAGE NUMBER",	$
"TRVAL2  =                    0 /",	$
"TDELT2  =                  100 /",	$
"TRPIX2  =                    1 /",	$
"TFORM3  = '4096E  '            / ndim*ndim ARRAY, type real*4",	$
"TTYPE3  = 'STOKESI'           /",	$
"TDIM3   = '(64,64 )'           / two dimensional array",	$
"TFORM4  = '4096E  '            / ndin*ndim ARRAY, type real*4",	$
"TTYPE4  = 'STOKESV'           /",	$
"TDIM4   = '(64,64) '           / two dimensional array",	$
"DATAMAX =                    0 /",	$
"DATAMIN =                    0 /",	$
"END"	]
  nmot=n_elements(tab)
; chaine servant a completer par des blancs la ligne contenant le mot cle
  header=strarr(nmot)
; boucle sur les mot-cles fits
  for i=0,nmot-1 do begin
  chaine=string(replicate(32b,80))
      strput,chaine,tab(i),0
      header(i)=chaine
  endfor
end
