pro rh_cr_header_pr,header
;+ ***********************************************************************
; NAME:
;	RH_CR_HEADER_PR
; PURPOSE:
;	Cette procedure cree un header fits primaire modele pour les fichiers
;	2D FITS type binary table, fichier de lignes contenant des images 
;	ou des harmoniques des donnees 2D Nancay .
;	Ce header modele est ensuite mis a jour par les programmes dpatchfits 
;	et de conversion harmoniques-images 
; CATEGORY: 
;	Traitement de fichiers NRH
; CALLING SEQUENCE:
;	RH_CR_HEADER_PR, header
; OUTPUTS:
;	Header:	header
; MODIFICATION HISTORY:
;	Ecrit par: A. Bouteille
;-*******************************************************************
;0000000001111111111222222222233333333334444444444555555555566666666667
;1234567890123456789012345678901234567890123456789012345678901234567890
; 36 lignes au maximum
tab=[	$
"SIMPLE  =                    T /",	$
"BITPIX  =                  -32 /",	$
"NAXIS   =                    0 /",	$
"DATE    = '27/10/82'           / Date of file creation",     $
"DATE-OBS= '27-OCT-82'          /",     $
"DATE_OBS= '1982-10-27T00:00:00.000Z'/", $
"DATE_END= '1982-10-27T00:00:00.000Z'/", $
"WAVELNTH=                  1.8 /", $
"WAVEUNIT=                    0 / in meters ",    $
"PHYSPARA= 'STOKESI+V'          /",     $
"OBJECT  = 'FS      '           /",	$
"OBS_TYPE= 'RADIO   '           /",     $
"OBS_MODE= 'SERIES  '           /",     $
"INSTITUT= 'MEUDON  '           /",     $
"CMP_NAME= 'ROUTINE '           /",     $ 
"CONTACT = ' A. KERDRAON'       /",     $                   
"TELESCOP= 'NRH'                / Nancay Radioheliograph",     $
"INSTRUME= 'NRH2'               / Nancay 2D-images Radioheliograph",  $
"FILENAME= 'nrh2_1640_a70_19960701_120000:00_b.fts'/",     $
"NRH_DATA= '2DI     '           / 2 dimensions images",     $
"ORIGIN  = '        '           /",     $ 
"EXTEND  =                    T / file may contain extensions ",      $
"END"	]
  nmot=n_elements(tab)
; chaine servant a completer par des blancs la ligne contenant le mot cle
  header=strarr(nmot)
; boucle sur les mot-cles fits
  for i=0,nmot-1 do begin
  chaine=string(replicate(32b,80))
      strput,chaine,tab(i),0
      header(i)=chaine
  endfor
end
; mettre a jour DATE
;		DATE_OBS
;		DATE_END
;               WAVELNTH
;               PHYSPARA
;		OBS_MODE  SERIES ou FULLSUN ou SINGLE?
;		CMP_NAME
;		FILENAME
