PRO RH_FRQCNT, kdeb, kfin, numcnt
;+ ***********************************************************************
; NAME:
;	RH_FRQCNT
; PURPOSE:
;	Cette procedure compte le nombre d'acq par frequence entre kdeb et 
;	kfin
;	il faut 8 minutes pour parcourir 5 * 10 000 acq ( un fichier 
;	comprime d'une journee a 2i/sec). Donc environ 10 sec pour 1000 images
; CATEGORY:
;	Traitement de fichiers RH
; INPUTS:
;	kdeb	: n0 d'acq de depart
;	kfin	: n0 d'acq de fin
; OUTPUTS
;	numcnt	: nb d'acq a chq frequence	LONARR(entfi.nf)
;		:  (NP + P) compte pour une seule acq
; MODIFICATION HISTORY:
;	Ecrit par A. Bouteille
;-**************************************************************************  
    @rh_common.inc
    numcnt = lonarr(entfi.nf)
    FOR klu= kdeb, kfin DO BEGIN
	nof = rh_readf(klu)
	numcnt(nof) = numcnt(nof) +1L
    ENDFOR
END
