;+ ***********************************************************************
; NAME:
;	CW_HEADER
;
; PURPOSE:
;	Cette procedure visualise le contenu du HEADER d'un fichier FITS
;       du NRH
;
; CATEGORY:
;	COMPOUND_WIDGET
;
; CALLING SEQUENCE:
;	CW_HEADER, File
;
; INPUT:
;	FILE	Nom du fichier
;
; KEYWORD OARAMETERS:
;	GROUP	Identification du widget appelant
;
;	EXTEN	Numero de l'extension, 1ere extension = 1
;
; COMMON BLOCKS:
;	Non

; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin le 19/12/97
;	le 06/11/98 Nom du fichier en argument remplace le COMMON FICRH
;		    supression du controle de nombre d'extensions (JB)
;-*******************************************************************

PRO CW_HEADER_EVENT, event

       WIDGET_CONTROL, event.top, /DESTROY

END

PRO CW_HEADER, File, EXTEN = Exten, GROUP = Group

IF N_ELEMENTS(Group) EQ 0 THEN Group = 0

base = WIDGET_BASE( GROUP_LEADER= group, /align_center, /Modal)

If FILE eq ' ' OR STRLEN(FILE) EQ 0 THEN BEGIN
        Ret = WIDGET_MESSAGE('SELECT a FILE')
        Return
        END

	Header = HEADFITS(file)

IF KEYWORD_SET (EXTEN) AND Exten GT 0 THEN BEGIN
	IF FXPAR(Header,'EXTEND') LT 0 THEN BEGIN
		Mes=WIDGET_MESSAGE('NO extension on this file')
		Return & END

	Header = HEADFITS(File,EXTEN = Exten)

	SZ = SIZE(header)
	IF Sz(2) NE 7 THEN BEGIN
		Mes= WIDGET_MESSAGE('This EXTENSION not exist')
	RETURN & END

ENDIF

       B= WIDGET_TEXT(Base, value = Header, Xsize= 80, Ysize=30,/SCROLL)

       B= WIDGET_BUTTON(Base, Value= 'DONE', Uvalue = 'Done', $
			      Xsize=100,/align_center)

WIDGET_CONTROL,Base,/REALIZE

XMANAGER, 'CW_HEADER', base, /NO_BLOCK

END