
;+ ***********************************************************************
; NAME:
;	I2CDATE
;
; PURPOSE:
;	Cette procedure convertit la date en binaire, en chaine de caracteres 
;
; CATEGORY:
;	NRH1 General
;
; CALLING SEQUENCE:
;	I2CDATE, Idate, Chdate	
;
; INPUTS:
;	IDATE	Tableau de 3 valeurs	IDATE[0] = Jour
;					IDATE[1] = Mois
;					IDATE[2] = An
;	
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	CHDATE	Chaine de caracteres contenant YY-MMM-DDD
;
; COMMON BLOCKS:
;	Non
;
; SIDE EFFECTS:
;	La chaine de caracteres est decodee en fonction de la position des
;	caracteres dans la chaine, donc le separateur peut etre quelconque
;
; PROCEDURE:
;	La conversion inverse est faite par C2IDATE
;
; EXAMPLE:
;	IDATE= [98, 04, 20]
;	C2IDATE, Idate,Cdate
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)

;- ***********************************************************************
pro i2cdate, idate, chdate
mois =['JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC']
;mois =['JAN','FEV','MAR','AVR','MAI','JUN','JUI','AOU','SEP','OCT','NOV','DEC']
chdate    =STRCOMPRESS( STRING(format="(i2.2,'-',a3,'-',i4.4)",$
   idate(0),mois(idate(1)-1),rh_date100(idate(2),/full)) ,/remove_all)  
return
end


