; NAME:
;	NRH1_FILEINFO__DEFINE
;
; CONTENTS:
;	Definition de la structure NRH1_STR_FILEINFO
;
;  nblocs	integer*4 nb de blocs de l'entete
;  nbtete	integer*4 nb de mots de l'entete d'image
;  imint	integer*4 type d'entete d'image 1 entiere 0 reelle
;  nbpix	lonarr(5) nb de valeurs par axe
;  nbaxes	integer*4 nb d'axes
;  orgint	lonarr(5) type d'axes 1 entier 0 reel
;  valorg	fltarr(5) valeur de l'origine sur l'axe
;  valmin	real*4    minimum
;  paspix	fltarr(5) valeur du pas par axe
;  valmax	real*4    maximum
;  facbloc	lonarr(5) facteur de blocage par axe
;  nblsup	integer*4 nb de lignes supplementaires
;  tfich	integer*4 taille du fichier en octets
;  tenre	integer*4 taille de l'enrgt en mots
;  heurdeb	integer*4 heure de debut en ms
;  heurfin	integer*4 heure de fin   en ms
;  date		string jj-mmm-aaaa
;  nomfich	chaine nom du fichier
;  texte	structure textinfo
; la structure textinfo contient les mot-cles
;	mot		strarr(taillemax) mot-cles
;	val		strarr(taillemax) valeur des mot-cles
;
; MODIFICATION HISTORY:
;	12/11/98 Cree (bonmartin@obspm.fr)
;-************************************************************************

PRO NRH1_FILEINFO__DEFINE

    nrh1_fileinfo  = { nrh1_fileinfo , nblocs:0l, nbtete:0l, $
	imint:0l, nbpix:lonarr(5),  $
	nbaxes:0l, $
	orgint:lonarr(5), valorg:Fltarr(5), $
	valmin:0. , paspix:Fltarr(5), $
	valmax:0. , $
	facbloc:lonarr(5), nblsup:0l, tfich:0l, tenre:0l, $
	heurdeb:0l, heurfin:0l, date : '', $
	nomfich:'', texte:{nrh1_textinfo} }
 
END